#ifndef CIRCUMD_CONF_H
#define CIRCUMD_CONF_H 1

#include <sys/socket.h>
#include <stdbool.h>
#include <stdint.h>
#include <libHX/clist.h>
#include <libcircum/net.h>

struct circumd_server_socket {
	struct HXlist_head list;
	uint8_t l3proto, l4proto;
	uint16_t port;
	int fd;
	bool mandatory, tls;
	union {
		struct sockaddr_in inet4;
		struct sockaddr_in6 inet6;
	};
};

/**
 * circumd_conn - connection within circumd
 * @sv_socket:	server-side socket through which client was received
 * @l_conn:	underlying low-level connection
 */
struct circumd_conn {
	const struct circumd_server_socket *sv_socket;
	struct a3_conn *l_conn;
};

struct circumd_config {
	struct HXclist_head server_sockets;
	unsigned int libcircum_debug_flags, single_threaded;
	bool libcircum_debug;
};

/*
 *	main.c
 */
extern struct HXlist_head circumd_modules;
extern bool circumd_running;

/*
 *	conf.c
 */
extern bool circumd_get_options(int *, const char ***, struct circumd_config *);

/*
 *	socket.c
 */
extern bool circumd_server_loop(struct circumd_config *);
extern bool circumd_create_sockets(struct circumd_config *);
extern void circumd_destroy_sockets(const struct circumd_config *);

#endif /* CIRCUMD_CONF_H */
