/*
 *	genuserhash
 *	Copyright © Konni Hartmann, 2008
 *
 *	This file is part of Codename Circumference. It is free software;
 *	you can redistribute it and/or modify it under the terms of the GNU
 *	Lesser General Public License as published by the Free Software
 *	Foundation, either version 3 of the License, or any later version.
 */
#include <stdio.h>
#include <stdlib.h>
#include <openssl/md5.h>
#include "digcalc.h"

int main(int argc, const char **argv)
{
	char hash[MD5_DIGEST_LENGTH*2+1];

	if (argc != 4) {
		fprintf(stderr, "Usage: %s <username> <realm> <password>\n",
		        *argv);
		return EXIT_FAILURE;
	}

	digest_calc_ha1("MD5", argv[1], argv[2], argv[3], NULL, NULL, hash);
	printf("%s:%s:%s\n", argv[1], argv[2], hash);
	return EXIT_SUCCESS;
}
