
%define apache_libexecdir %(%_sbindir/apxs2 -q LIBEXECDIR)

Name:		circumference
Version:	1.2
Release:	0
Group:		Productivity/Networking
Summary:	Diameter Authentication/Authorization Server and Client
License:	GPL3
URL:		http://circum.sf.net/

Source:		%name-%version.tar.bz2
BuildRoot:	%_tmppath/%name-%version-build
BuildRequires:	apache2-devel >= 2.0, gcc-c++ >= 4.3, pam-devel >= 0.99.6
BuildRequires:	pcre-devel >= 7.4, pkg-config >= 0.19
BuildRequires:	libHX-devel >= 2.0, libopenssl-devel >= 0.9.7
BuildRequires:	libxml2-devel >= 2.6

%define opt 1

%description
Circumference is an implementation of the Diameter AAA
(Authentication, Authorization and Accounting) protocol with focus on
the Diameter WebAuth Application.

Author(s):
----------
	Jan Engelhardt <jengelh@medozas.de>
	Konni Hartmann <nnex.ai@googlemail.com>
	Alexander Kiok <akiok@math.uni-goettingen.de>
	Niklas Neumann <niklas.neumann@cs.uni-goettingen.de>

%prep
%setup -q

%build
%if %opt
%configure --prefix=/opt/%name \
	--bindir=/opt/%name/bin --sbindir=/opt/%name/sbin \
	--libdir=/opt/%name/%_lib --with-pkglibdir=/opt/%name/%_lib \
	--includedir=/opt/%name/include	--with-pkgdatadir=/opt/%name/share \
	--with-pkgconfigdir=%_libdir/pkgconfig \
	--with-apxs=%_sbindir/apxs2
%else
%configure
%endif
make %{?jobs:-j%jobs};

%install
b="%buildroot";
rm -Rf "$b";
make install DESTDIR="$b";
mkdir -p "$b/%_initrddir";
install -pm0755 dist/circumd "$b/%_initrddir/";

%clean
rm -Rf "%buildroot";

%post
%stop_on_removal circumd

%files
%defattr(-,root,root)
%_initrddir/*
%apache_libexecdir/*
%dir %_sysconfdir/%name
%config(noreplace) %_sysconfdir/%name/*
%doc %_mandir/*/*
%_libdir/pkgconfig/*
%if %opt
/opt/%name
%else
%_sbindir/*
%_includedir/*
%_libdir/*.so*
%_libdir/pkgconfig/*
%_libdir/%name
%_datadir/%name
%endif
