/*
 *	Copyright © Jan Engelhardt, 2008
 */
#include "colors.inc"

global_settings {
	charset utf8
	max_trace_level 256
}

#declare spec_coeff = 0.5;
#declare zdepth = 5;

#macro ring()
	difference {
		cylinder {
			<0, 0, 0>, <0, 0, zdepth>, 64
			pigment { color Orange }
			finish { specular spec_coeff reflection { 1 metallic 0.4 } }
		}
		cylinder {
			<0, 0, -.01>, <0, 0, zdepth + .01>, 60
			pigment { color Orange }
			finish { specular spec_coeff reflection { 1 metallic 0.4 } }
		}
		#declare ii = 15;
		#while (ii < 90)
		box {
			<0, 0, -.01>, <zdepth, 65, zdepth + .01>
			pigment { color Orange }
			rotate z * -ii
		}
			#declare ii = ii + 15;
		#end
		translate <0, 0, -zdepth / 2>
	}
#end

union {
	object {
		ring()
		rotate z * clock * -2/3
		rotate x * clock
	}

	text {
		ttf "times.ttf" "2\u03c0r" zdepth / 80, 0
		scale 80
		pigment { color Orange }
		finish { reflection { 1 metallic 0.6 } ambient 0.3 }
		translate <-50, -24, 0>
		translate <0, 0, -zdepth / 2>
	}

}

/* Debugging axes */
/*
cylinder { <-100, 0, 0>, <100, 0, 0>, 1 pigment { color Red } }
cylinder { <0, -100, 0>, <0, 100, 0>, 1 pigment { color Green } }
cylinder { <0, 0, -100>, <0, 0, 100>, 1 pigment { color Blue } }
*/

light_source { <-50, -50, -30>, White }
light_source { <50, 50, -30>, White }
light_source { <-1000, -1000, 1000>, White/2 }
light_source { <1000, -1000, 1000>, White/2 }
light_source { <-1000, 1000, 1000>, White/2 }
light_source { <1000, 1000, 1000>, White/2 }

camera {
	location <0, 0, -150>
	look_at <0, 0, 0>
}
