#ifndef _LIBCIRCUMFERENCE_DEBUG_H
#define _LIBCIRCUMFERENCE_DEBUG_H 1

#ifdef __cplusplus
extern "C" {
#endif

struct a3_avp;
struct a3_packet;

/**
 * circum_debug_flags
 * %CIRCUM_VERBOSE_TREE:	print more fields during a3_treedump_pkt()
 * %CIRCUM_DUMP_TREE:		dump packet tree on network send/receive
 * %CIRCUM_DUMP_WPKT:		wire packet hexdump on network send/recv
 * %CIRCUM_OTHER:		anything else
 */
enum circum_debug_flags {
	CIRCUM_VERBOSE_TREE = 1 << 0,
	CIRCUM_DUMP_TREE    = 1 << 1,
	CIRCUM_DUMP_WPKT    = 1 << 2,
	CIRCUM_DEBUG_OTHER  = 1 << 3,
};

/* debug.c */
extern unsigned int circum_debug(unsigned int);
extern void circum_treedump_avp(const struct a3_avp *, unsigned int);
extern void circum_treedump_pkt(const struct a3_packet *, unsigned int);
extern void circum_hexdump(const void *, unsigned int);

/* idmap.c */
extern void circum_idmap_dump(void);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _LIBCIRCUMFERENCE_DEBUG_H */
