#ifndef _LIBCIRCUMFERENCE_INTERNAL_H
#define _LIBCIRCUMFERENCE_INTERNAL_H 1

#include <sys/types.h>
#ifndef __cplusplus
#	include <stdbool.h>
#endif
#include <libHX/list.h>
#include <libxml/parser.h>
#include <libHX/list.h>

#ifdef __cplusplus
extern "C" {
#endif

struct a3_conn;
struct a3_idmap_avp;
struct a3_idmap_cmd;

struct circum_avprule {
	struct HXlist_head list;
	const struct a3_idmap_avp *avp_id;
	unsigned int min, max;
	bool required;
};

struct circum_xmltag_map {
	const char *name;
	const char *(*func)(xmlNode *, void *);
};

/* debug.c */
extern unsigned int circum_debug_flags;

/* idmap.c */
extern struct a3_idmap_cmd *circum_idmap_cmd_code(unsigned int);
extern struct a3_idmap_avp *circum_idmap_avp_name(const char *);
extern struct a3_idmap_avp *circum_idmap_avp_code(unsigned int);
extern const char *circum_dict_recursive(const struct circum_xmltag_map *,
	xmlNode *, void *);
extern void circum_idmap_init(void);
extern void circum_idmap_exit(void);

/* idmap-verify.c */
extern const struct circum_xmltag_map circum_dict_vfytop_tags[];

/* net.c */
extern void circum_net_init(void);

/* packet.c */
extern unsigned int circum_ntoh24(unsigned int);

/* tls.c */
extern ssize_t circum_tls_recv(const struct a3_conn *, void *, size_t);
extern ssize_t circum_tls_send(const struct a3_conn *, const void *, size_t);
extern void circum_tls_exit(void);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _LIBCIRCUMFERENCE_INTERNAL_H */
