#ifndef _LIBCIRCUMFERENCE_NET_H
#define _LIBCIRCUMFERENCE_NET_H 1

#include <sys/types.h>
#ifdef __cplusplus
#	include <cstdint>
#else
#	include <stdbool.h>
#	include <stdint.h>
#endif

struct a3_packet;

/**
 * @tls_request:	Establish a secured connection
 * @tls_active:		TLS is active
 */
struct a3_conn {
/* public: */
	char *session_id;
	uint32_t appl_id;
	bool tls_request;

/* private: */
	char *local_addr, *local_host, *remote_host;
	void *tls_data;
	int fd;
	uint16_t l3proto;
	bool tls_active;
};

#ifdef __cplusplus
extern "C" {
#endif

extern ssize_t circum_net_recv(int, void *, size_t);
extern void *circum_conn_recv_bpkt(struct a3_conn *, unsigned int *);
extern ssize_t circum_net_send(int, const void *, size_t);

extern struct a3_conn *a3_conn_new(void);
extern bool a3_conn_open(struct a3_conn *, const char *);
extern struct a3_packet *a3_conn_recv(struct a3_conn *);
extern ssize_t a3_conn_send(struct a3_conn *, struct a3_packet *);
extern void a3_conn_close(struct a3_conn *);
extern void circum_conn_free(struct a3_conn *);

/* tls.c */
extern bool circum_conn_starttls(struct a3_conn *, bool);
extern void circum_conn_leavetls(struct a3_conn *);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _LIBCIRCUMFERENCE_NET_H */
