#ifndef _LIBCIRCUMFERENCE_WIREPACKET_H
#define _LIBCIRCUMFERENCE_WIREPACKET_H 1

/**
 * a3_wire_packet - wire representation of an AAA packet
 */
struct a3_wire_packet {
	uint8_t version;
	uint32_t length:24;
	uint8_t cmdflags;
	uint32_t command:24;
	uint32_t appl_id;
	uint32_t hbh_id;
	uint32_t ete_id;
};

/**
 * a3_wire_avp - wire representation of an AVP without vendor tag
 */
struct a3_wire_avp {
	uint32_t code;
	uint8_t flags;
	uint32_t length:24;
};

/**
 * a3_wire_avp_vendor - wire representation of an AVP with vendor tag
 */
struct a3_wire_avp_vendor {
	uint32_t code;
	uint8_t flags;
	uint32_t length:24;
	uint32_t vendor_id;
};

#endif /* _LIBCIRCUMFERENCE_WIREPACKET_H */
